"use strict";

exports.__esModule = true;
exports.ariaHidden = ariaHidden;
exports.hideSiblings = hideSiblings;
exports.showSiblings = showSiblings;
const BLACKLIST = ['template', 'script', 'style'];

const isHidable = ({
  nodeType,
  tagName
}) => nodeType === 1 && BLACKLIST.indexOf(tagName.toLowerCase()) === -1;

const siblings = (container, exclude, cb) => {
  [].forEach.call(container.children, node => {
    if (exclude.indexOf(node) === -1 && isHidable(node)) {
      cb(node);
    }
  });
};

function ariaHidden(hide, node) {
  if (!node) return;

  if (hide) {
    node.setAttribute('aria-hidden', 'true');
  } else {
    node.removeAttribute('aria-hidden');
  }
}

function hideSiblings(container, {
  dialog,
  backdrop
}) {
  siblings(container, [dialog, backdrop], node => ariaHidden(true, node));
}

function showSiblings(container, {
  dialog,
  backdrop
}) {
  siblings(container, [dialog, backdrop], node => ariaHidden(false, node));
}