import * as React from 'react';
export interface AnchorProps extends React.HTMLAttributes<HTMLElement> {
    as?: React.ElementType;
    href?: string;
    disabled?: boolean;
    role?: string;
    tabIndex?: number;
}
/**
 * An generic `<a>` component that covers a few A11y cases, ensuring that
 * cases where the `href` is missing or trivial are treated like buttons
 */
declare const Anchor: React.ForwardRefExoticComponent<AnchorProps & React.RefAttributes<HTMLAnchorElement>>;
export default Anchor;
