import * as React from 'react';
import { DynamicRefForwardingComponent } from './types';
export declare type ButtonType = 'button' | 'reset' | 'submit' | string;
interface UseButtonPropsOptions {
    type?: ButtonType;
    href?: string;
    disabled?: boolean;
    target?: any;
    rel?: string;
    onClick?: React.EventHandler<React.MouseEvent | React.KeyboardEvent>;
    tabIndex?: number;
}
export declare function useButtonProps({ tagName, disabled, href, target, rel, onClick, tabIndex, }: UseButtonPropsOptions & {
    tagName: string;
}): {
    disabled: boolean | undefined;
    role?: undefined;
    tabIndex?: undefined;
    href?: undefined;
    target?: undefined;
    'aria-disabled'?: undefined;
    rel?: undefined;
    onClick?: undefined;
    onKeyDown?: undefined;
} | {
    role: string;
    tabIndex: number | undefined;
    href: string | undefined;
    target: any;
    'aria-disabled': true | undefined;
    rel: string | undefined;
    onClick: (event: React.MouseEvent | React.KeyboardEvent) => void;
    onKeyDown: (event: React.KeyboardEvent) => void;
    disabled?: undefined;
};
export interface ButtonProps extends Omit<React.HTMLAttributes<HTMLElement>, 'onClick'>, UseButtonPropsOptions {
    as?: React.ElementType;
}
declare const Button: DynamicRefForwardingComponent<'button', ButtonProps>;
export default Button;
