import * as React from 'react';
import { EventKey, DynamicRefForwardingComponent } from './types';
import Button from './Button';
export interface NavItemProps extends Omit<React.HTMLAttributes<HTMLElement>, 'onSelect'> {
    active?: boolean;
    as: React.ElementType;
    disabled?: boolean;
    eventKey?: EventKey;
    href?: string;
    tabIndex?: number;
    onSelect?: (navKey: string, e: any) => void;
}
export interface UseNavItemOptions {
    key?: string | null;
    onClick?: React.MouseEventHandler;
    active?: boolean;
    disabled?: boolean;
    id?: string;
    role?: string;
}
export declare function useNavItem({ key, onClick, active, id, role, disabled, }: UseNavItemOptions): readonly [any, {
    readonly isActive: boolean | undefined;
}];
declare const NavItem: DynamicRefForwardingComponent<typeof Button, NavItemProps>;
export default NavItem;
