import * as React from 'react';
export declare type EventKey = string | number;
export declare type AssignProps<Inner extends React.ElementType, P> = Omit<React.ComponentPropsWithRef<Inner>, keyof P> & P;
export interface DynamicRefForwardingComponent<TInitial extends React.ElementType, P = unknown> {
    <As extends React.ElementType = TInitial>(props: React.PropsWithChildren<AssignProps<As, {
        as?: As;
    } & P>>, context?: any): React.ReactElement | null;
    propTypes?: any;
    contextTypes?: any;
    defaultProps?: Partial<P>;
    displayName?: string;
}
export declare class DynamicComponent<As extends React.ElementType, P = unknown> extends React.Component<AssignProps<As, {
    as?: As;
} & P>> {
}
export declare type DynamicComponentClass<As extends React.ElementType, P = unknown> = React.ComponentClass<AssignProps<As, {
    as?: As;
} & P>>;
export declare type SelectCallback = (eventKey: string | null, e: React.SyntheticEvent<unknown>) => void;
export interface TransitionCallbacks {
    onEnter?(node: HTMLElement): any;
    onEntered?(node: HTMLElement): any;
    onEntering?(node: HTMLElement): any;
    onExit?(node: HTMLElement): any;
    onExited?(node: HTMLElement): any;
    onExiting?(node: HTMLElement): any;
}
export interface TransitionProps extends TransitionCallbacks {
    in?: boolean;
    appear?: boolean;
    children: React.ReactElement;
    mountOnEnter?: boolean;
    unmountOnExit: boolean;
}
export declare type TransitionComponent = React.ComponentType<TransitionProps>;
export declare type TransitionType = boolean | TransitionComponent;
